Subject: Re: [PATCH v1] netfilter: nf_tables: fix nft_set_elem_init heap buffer overflow

From: Pablo Neira Ayuso <[email-masked]>
Date: Sat, 2 Jul 2022 21:11:56 +0200

On Sat, Jul 02, 2022 at 08:57:14PM +0200, Pablo Neira Ayuso wrote:
> On Sat, Jul 02, 2022 at 07:59:11PM +0200, Hugues ANGUELKOV wrote:
> > From d91007a18140e02a1f12c9627058a019fe55b8e6 Mon Sep 17 00:00:00 2001
> > From: Arthur Mongodin <[email-masked]>
> > Date: Sat, 2 Jul 2022 17:11:48 +0200
> > Subject: [PATCH v1] netfilter: nf_tables: fix nft_set_elem_init heap buffer
> >  overflow
> > 
> > The length used for the memcpy in nft_set_elem_init may exceed the bound
> > of the allocated object due to a weak check in nft_setelem_parse_data.
> > As a user can add an element with a data type NFT_DATA_VERDICT to a set
> > with a data type different of NFT_DATA_VERDICT, then the comparison on the
> > data type of the element allows to avoid the comparaison on the data length
> > This fix forces the length comparison in nft_setelem_parse_data by removing
> > the check for NFT_DATA_VERDICT type.
> 
> https://patchwork.ozlabs.org/project/netfilter-devel/patch/[email-masked]/

For the record, pull request is already available with pending fixes
for net.

https://patchwork.ozlabs.org/project/netfilter-devel/patch/[email-masked]/
https://patchwork.ozlabs.org/project/netfilter-devel/patch/[email-masked]/
https://patchwork.ozlabs.org/project/netfilter-devel/patch/[email-masked]/